#include "w_volume_bar.h"

#include "arona_application.h"
#include "tool/math/lerp.h"

w_volume_bar::w_volume_bar(bool vertical) : is_vertical(vertical)
{
    set_content_height(10);
    set_content_width(10);
    set_draw_func(sigc::mem_fun(*this, &w_volume_bar::on_draw));
}

void w_volume_bar::on_draw(const Cairo::RefPtr<Cairo::Context>& cr, int width, int height) {
    // Draw a black rectangle.
    cr->set_source_rgba(0.0, 0.0, 0.0, 1.0);
    cr->fill();

    // draw value bar
    cr->set_source_rgba(0.0, 1.0, 1.0, 1.0);
    if (is_vertical) {
        cr->rectangle(0, height * (1 - value_), width, height * value_);
    } else {
        cr->rectangle(0, 0, width * value_, height);
    }
    cr->fill();

    cr->stroke();
}
