#pragma once
#include <giomm/liststore.h>
#include <gtkmm/box.h>
#include <gtkmm/listview.h>
#include <gtkmm/signallistitemfactory.h>
#include <gtkmm/singleselection.h>

#include "w_mixer_track.h"
#include "audio/mixer/mixer_track.h"

class mixer_list_model : public Glib::Object {
public:
    mixer_track* mixer;
    static Glib::RefPtr<mixer_list_model> create(mixer_track* mixer) {
        return Glib::make_refptr_for_instance(new mixer_list_model(mixer));
    }
protected:
    explicit mixer_list_model(mixer_track* mixer) : mixer(mixer) {}
};

class w_mixer_list : public Gtk::Box {
public:
    w_mixer_list();
    ~w_mixer_list() override;
private:
    void on_add_track(mixer_track* mixer_track);
    void on_remove_track(mixer_track* mixer_track);

    void on_setup_track_widget(const Glib::RefPtr<Gtk::ListItem>& item);
    void on_bind_track_widget(const Glib::RefPtr<Gtk::ListItem>& item);
    void on_selection_changed();
    Glib::RefPtr<Gio::ListStore<mixer_list_model>> data_model_;
    Glib::RefPtr<Gtk::SingleSelection> selection_model_;
    Glib::RefPtr<Gtk::SignalListItemFactory> factory_;

    Gtk::ListView list_view_;

    w_mixer_track* master_track_;
};
